Unit MLC4W_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLC4C_p, MLC4E_p;

procedure MLC4W(var NA :Array of Integer; var NS :Array of Integer;
                var NAI :Array of Integer; var NAJ :Array of Integer;
                L :Integer; var NB :Array of Integer;
                var NR1 :Array of Integer; var NR2 :Array of Integer;
                var NVK :Array of Integer; IS_ :Integer;
                M :Integer; N :Integer; N1 :Integer;
                MN :Integer; var IV :Integer);

implementation

procedure MLC4W(var NA :Array of Integer; var NS :Array of Integer;
                var NAI :Array of Integer; var NAJ :Array of Integer;
                L :Integer; var NB :Array of Integer;
                var NR1 :Array of Integer; var NR2 :Array of Integer;
                var NVK :Array of Integer; IS_ :Integer;
                M :Integer; N :Integer; N1 :Integer;
                MN :Integer; var IV :Integer);
var
IVK,I,IR,K,M1 :Integer;
A,A3,R,TETA,TETA1 :Real;
const
CTETA :Real = 1.0E17;
EPS :Real = 1.0E-7;
label
_10,_20,_30,_40,_50,_60;
begin
{   ------------------------------------------ }
{      }
{   ------------------------------------------ }
TETA1 := CTETA;
M1 := M+N+2;
MLC4C(NA,NS,NAI,NAJ,L,NB,NR1,1,M,
     N,N1,MN);
MLC4C(NA,NS,NAI,NAJ,L,NB,NR2,IS_,
     M,N,N1,MN);
for I:=2 to M1 do
 begin
  if ( NR2[I-1] ) < 0
   then goto _20
   else if ( NR2[I-1] ) > 0
         then goto _10
         else goto _20;
_10:
  A3 := NR2[I-1];
  A := NR1[I-1];
  R := A/A3*(1+EPS);
  if ( TETA1 > R ) 
   then TETA1 := R;
_20:
 end;
TETA := TETA1;
for I:=2 to M1 do
 begin
  if ( NR2[I-1] <= 0 ) 
   then goto _30;
  IR := MLC4E(NR1[I-1],NR2[I-1]);
  A := IR;
  if ( IR >= 0 ) and ( A <= TETA*(1.0+EPS) ) 
   then goto _40;
_30:
  NVK[I-1] := 0;
  goto _50;
_40:
  NVK[I-1] := NVK[I-1]+1;
_50:
 end;
K := -1;
for I:=2 to M1 do
 begin
  if ( K >= NVK[I-1] ) 
   then goto _60;
  K := NVK[I-1];
  IV := I;
_60:
 end;
end;

end.
