Unit mlc4z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLC4S_p;

procedure mlc4z(var NA :Array of Integer; var NS :Array of Integer;
                var NAI :Array of Integer; var NAJ :Array of Integer;
                L :Integer; var NB :Array of Integer;
                var NSK :Array of Integer; var NR :Array of Integer;
                var NT :Array of Integer; M :Integer;
                N :Integer; N1 :Integer; MN :Integer;
                var IS_ :Integer);

implementation

procedure mlc4z(var NA :Array of Integer; var NS :Array of Integer;
                var NAI :Array of Integer; var NAJ :Array of Integer;
                L :Integer; var NB :Array of Integer;
                var NSK :Array of Integer; var NR :Array of Integer;
                var NT :Array of Integer; M :Integer;
                N :Integer; N1 :Integer; MN :Integer;
                var IS_ :Integer);
var
I,IP,J,M1 :Integer;
AMIN,Q,W :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80;
begin

{  / BOPA POBOEO CTOA }

NSK[0] := -1;
IP := 0;
M1 := M+N+2;
{    CTPOKA M1 BOCCTAHABBAETC B MACCBE NT }
MLC4S(NA,NS,NAI,NAJ,L,NB,NT,M1,M,N,N1,MN);
for J:=2 to N1 do
 begin
  if ( NT[J-1] ) < 0
   then goto _10
   else if ( NT[J-1] ) > 0
         then goto _20
         else goto _10;
_10:
  NSK[J-1] := -1;
  IP := IP+1;
  goto _30;
_20:
  NSK[J-1] := J;
  IS_ := J;
_30:
 end;
for I:=1 to M1 do
 begin
  if ( IP = N1-2 ) 
   then goto _80;
  AMIN := 0.0;
  MLC4S(NA,NS,NAI,NAJ,L,NB,NR,I,M,N,N1,MN);
  for J:=1 to M1 do
   begin
    Q := NR[J-1];
    AMIN := AMIN+Abs(Q)+1;
_40:
   end;
  for J:=2 to N1 do
   begin
    if ( NSK[J-1] < 0 ) 
     then goto _50;
    W := NT[J-1];
    W := NR[J-1]/W;
    if ( AMIN <= W ) 
     then goto _50;
    AMIN := W;
    IS_ := J;
_50:
   end;
  for J:=2 to N1 do
   begin
    if ( NSK[J-1] < 0 )
     then goto _60;
    W := NT[J-1];
    W := NR[J-1]/W;
    if ( W <= AMIN )
     then goto _60;
    NSK[J-1] := -1;
    IP := IP+1;
_60:
   end;
_70:
 end;
_80:
end;

end.
